<template>
  <div class="wait-task-flow">
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList">
        <el-table-column
          type="index"
          label="序号"
          width="50"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="paperNumber"
          label="试卷编号"
          min-width="160"
        ></el-table-column>
        <el-table-column prop="type" label="课程（代码）" min-width="200">
          <template slot-scope="scope">
            {{ scope.row.courseName }}（{{ scope.row.courseCode }}）
          </template>
        </el-table-column>
        <el-table-column
          prop="cardRuleName"
          label="题卡规则"
          min-width="160"
        ></el-table-column>
        <el-table-column prop="taskName" label="流程节点" min-width="160">
          <span slot-scope="scope">
            {{ scope.row.taskName | flowTaskNameFilter }}
          </span>
        </el-table-column>
        <el-table-column prop="createTime" label="创建时间" width="170">
          <span slot-scope="scope">{{
            scope.row.createTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="100"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button class="btn-primary" type="text" @click="toDo(scope.row)"
              >立即处理</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total,prev, pager, next"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyTaskApply -->
    <modify-task-apply
      ref="ModifyTaskApply"
      :instance="curTask"
      @modified="taskModified"
    ></modify-task-apply>
  </div>
</template>

<script>
import { mapMutations, mapActions } from "vuex";
import { waitExamTaskListPage } from "../api";
import ModifyTaskApply from "./ModifyTaskApply";

export default {
  name: "wait-task-flow",
  components: { ModifyTaskApply },
  data() {
    return {
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      curTask: {}
    };
  },
  mounted() {
    this.initData();
  },
  methods: {
    ...mapMutations("exam", ["updateWaitTask"]),
    ...mapActions("exam", ["updateWaitTaskCount"]),
    async initData() {
      await this.getList();

      const presetTask = this.$ls.get("wait_task_flow");
      if (presetTask) {
        this.$nextTick(() => {
          this.toDo(presetTask);
        });
        this.$ls.remove("wait_task_flow");
      }
    },
    async getList() {
      const datas = {
        pageNumber: this.current,
        pageSize: this.size
      };
      const data = await waitExamTaskListPage(datas);
      this.dataList = data.records;
      this.total = data.total;
      this.updateWaitTask({ flow: this.total });
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toDo(task) {
      this.curTask = { ...task, source: "REVIEW" };
      this.$refs.ModifyTaskApply.open();
    },
    taskModified() {
      this.getList();
      this.updateWaitTaskCount();
    }
  }
};
</script>
